use std::time::Instant;

use utils::time::get_elapsed_string;
use y2015::days::d4;

fn main() {
    let now = Instant::now();
    println!("Part 1:");
    part1();
    println!("Ran in {}", get_elapsed_string(now.elapsed()));
    let now = Instant::now();
    println!("Part 2:");
    part2();
    println!("Ran in {}", get_elapsed_string(now.elapsed()));
}

fn part1() {
    let now = Instant::now();
    println!("{}", d4::process_part1("bgvyzdsv"));
    println!("{}µs", now.elapsed().as_micros());
}

fn part2() {
    let now = Instant::now();
    println!("{}", d4::process_part2("bgvyzdsv"));
    println!("{}µs", now.elapsed().as_micros());
}
