use utils::number::Number;

// 31562160 too high
pub fn process_part1(x: u32, y: u32) -> Number {
    // the grid is actually a pyramid
    //   1
    //  2 3
    // 4 5 6
    // etc
    // Num on top == 20151125
    let mut current = Number::from(20151125);
    let mut starting_y_idx = 2;
    loop {
        let mut x_idx = 1;
        for y_idx in (1..=starting_y_idx).rev() {
            current *= Number::from(252533);
            current %= Number::from(33554393);
            if x_idx == x && y_idx == y {
                return current;
            }
            x_idx += 1;
        }
        starting_y_idx += 1;
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn part1() {
        let result = process_part1(6, 6);
        assert_eq!(result, 27995004.into());
        let result = process_part1(1, 2);
        assert_eq!(result, 31916031.into());
    }
}
