use std::{fs, time::Instant};

use utils::time::get_elapsed_string;
use y2024::days::d12;

fn main() {
    let now = Instant::now();
    println!("Part 1:");
    part1();
    println!("Ran in {}", get_elapsed_string(now.elapsed()));
    let now = Instant::now();
    println!("Part 2:");
    part2();
    println!("Ran in {}", get_elapsed_string(now.elapsed()));
}

fn part1() {
    let root = env!("CARGO_MANIFEST_DIR");
    let content = fs::read_to_string(format!("{root}/resources/12_input.txt")).unwrap();
    println!("{}", d12::process_part1(&content));
}

fn part2() {
    let root = env!("CARGO_MANIFEST_DIR");
    let content = fs::read_to_string(format!("{root}/resources/12_input.txt")).unwrap();
    println!("{}", d12::process_part2(&content));
}
